"""Common types for FRED registry."""

from .common import BaseId, BaseModel
from .dnskey import DnskeyAlgorithm, DnskeyFlag, DnskeyProtocol
from .logger import LogEntryId
from .registry import (
    BaseObjectHistoryId,
    BaseObjectId,
    ContactHistoryId,
    ContactId,
    ContactRef,
    DomainHistoryId,
    DomainId,
    DomainRef,
    KeysetHistoryId,
    KeysetId,
    KeysetRef,
    NssetHistoryId,
    NssetId,
    NssetRef,
    RegistrarId,
    RegistrarRef,
    RegistryObjectType,
    RepresentativeHistoryId,
    RepresentativeId,
    SnapshotId,
    StateFlag,
)

__version__ = "2.2.0"

__all__ = [
    "BaseId",
    "BaseModel",
    "BaseObjectHistoryId",
    "BaseObjectId",
    "ContactHistoryId",
    "ContactId",
    "ContactRef",
    "DnskeyAlgorithm",
    "DnskeyFlag",
    "DnskeyProtocol",
    "DomainHistoryId",
    "DomainId",
    "DomainRef",
    "KeysetHistoryId",
    "KeysetId",
    "KeysetRef",
    "LogEntryId",
    "NssetHistoryId",
    "NssetId",
    "NssetRef",
    "RegistrarId",
    "RegistrarRef",
    "RegistryObjectType",
    "RepresentativeHistoryId",
    "RepresentativeId",
    "SnapshotId",
    "StateFlag",
]
