from unittest import TestCase

from fred_types import DnskeyAlgorithm, DnskeyFlag, DnskeyProtocol


class DnskeyAlgorithmTest(TestCase):
    def test_init(self):
        self.assertEqual(DnskeyAlgorithm(3), DnskeyAlgorithm.DSA)

    def test_attributes(self):
        self.assertEqual(DnskeyAlgorithm.DELETE.value, 0)
        self.assertEqual(DnskeyAlgorithm.DELETE.label, "Delete DS")


class DnskeyFlagTest(TestCase):
    def test_init(self):
        self.assertEqual(DnskeyFlag(1), DnskeyFlag.SECURE_ENTRY_POINT)

    def test_attributes(self):
        self.assertEqual(DnskeyFlag.ZONE.value, 256)
        self.assertEqual(DnskeyFlag.ZONE.bit, 7)
        self.assertEqual(DnskeyFlag.ZONE.label, "ZONE")

    def test_flags(self):
        dnskey = DnskeyFlag.ZONE | DnskeyFlag.REVOKE | DnskeyFlag._UNASSIGNED_2
        self.assertEqual(
            dnskey.flags, {DnskeyFlag.ZONE, DnskeyFlag.REVOKE, DnskeyFlag._UNASSIGNED_2}
        )


class DnskeyProtocolTest(TestCase):
    def test_init(self):
        self.assertEqual(DnskeyProtocol(3), DnskeyProtocol.DNSSEC)

    def test_attributes(self):
        self.assertEqual(DnskeyProtocol.DNSSEC.value, 3)
        self.assertEqual(DnskeyProtocol.DNSSEC.label, "DNSSEC")
